package com.bif.timecard.invoice;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

class InvoiceLaborCategoryGroup {
	private String stringLaborCategoryID;
	private String stringLaborCategoryName;
	private List<EmployeeHoursSummary> listOfEmployeeHoursSummary = new ArrayList<EmployeeHoursSummary>();
	
	public void setLaborCategoryID(String stringLaborCategoryIDNew) {
		this.stringLaborCategoryID = stringLaborCategoryIDNew;
	}
	
	public double getTruncatedDouble(String stringFormat, double doubleNumber) {
		DecimalFormat decimalFormat = new DecimalFormat(stringFormat);
		
		
		String stringDouble = decimalFormat.format(doubleNumber);
		/**
		 * Remove everything beyond the two digits after the decimal.
		 */
		String stringCopy = stringDouble;
		stringDouble = stringDouble.substring(0,stringDouble.length() - 2);
		return Double.parseDouble(stringDouble);
	}
	
	public double getTotalExtendedAmount() {
		double doubleSum = 0;
		
		for (EmployeeHoursSummary employeeHoursSummary : this.getEmployeeHoursSummary()) {
			doubleSum += InvoiceGenerator.getTruncatedDouble("########0.0000", employeeHoursSummary.getNonProfitHours() * employeeHoursSummary.getNonProfitHourlyRate());
			doubleSum += InvoiceGenerator.getTruncatedDouble("########0.0000", employeeHoursSummary.getProfitHours() * employeeHoursSummary.getProfitHourlyRate());
		}
		
		return doubleSum;
	}

	public double getTotalHours() {
		double doubleSum = 0;
		
		for (EmployeeHoursSummary employeeHoursSummary : this.getEmployeeHoursSummary()) {
			doubleSum += employeeHoursSummary.getNonProfitHours();
			doubleSum += employeeHoursSummary.getProfitHours();
		}
		
		return doubleSum;
	}

	public String getLaborCategoryID() {
		return this.stringLaborCategoryID;
	}
	
	public void setLaborCategoryName(String stringLaborCategoryNameNew) {
		this.stringLaborCategoryName = stringLaborCategoryNameNew;
	}
	
	public String getLaborCategoryName() {
		return this.stringLaborCategoryName;
	}
	
	public List<EmployeeHoursSummary> getEmployeeHoursSummary() {
		return this.listOfEmployeeHoursSummary;
	}
}