DECLARE
	varchar_billing_period_id	VARCHAR(100)	:=	?;
	varchar_invoice_section_id	VARCHAR(100)	:=	?;
	varchar_employee_id			VARCHAR(100)	:=	?; 
	varchar_first_name			VARCHAR(100) 	:=	?; 
	varchar_last_name			VARCHAR(100)	:=	?;
	varchar_labor_category_id	VARCHAR(100)	:=	?;
	
	boolean_record_found		BOOLEAN			:=	FALSE;
	
	CURSOR cursor_emp_inv_sect(
			varchar_billing_period_id		IN VARCHAR,
			varchar_invoice_section_id		IN VARCHAR,
			varchar_employee_id				IN VARCHAR,
			varchar_labor_category_id		IN VARCHAR
		) IS
		SELECT
			eis.employee_id,
			eis.billing_period_id
		FROM
			timecard.employee_invoice_section	eis
		WHERE
			eis.billing_period_id	=	varchar_billing_period_id
		AND	eis.invoice_section_id	=	varchar_invoice_section_id
		AND eis.employee_id			=	varchar_employee_id
		AND	eis.labor_category_id	=	varchar_labor_category_id;
BEGIN
	UPDATE
		timecard.employee e
	SET
		e.first_name		=	varchar_first_name,
		e.last_name			=	varchar_last_name
	WHERE
		e.employee_id		=	varchar_employee_id;
		
	IF (SQL%ROWCOUNT = 0) THEN
		INSERT INTO timecard.employee e (
			e.employee_id,
			e.first_name,
			e.last_name
		) VALUES (
			varchar_employee_id,
			varchar_first_name,
			varchar_last_name
		);
	END IF;
	
	FOR record_emp_inv_sect IN cursor_emp_inv_sect(varchar_billing_period_id, varchar_invoice_section_id, varchar_employee_id, varchar_labor_category_id) LOOP
		boolean_record_found	:=	TRUE;
	END LOOP;
	IF (boolean_record_found = FALSE) THEN
		INSERT INTO timecard.employee_invoice_section eis (
			billing_period_id,
			invoice_section_id,
			employee_id,
			labor_category_id
		) VALUES (
			varchar_billing_period_id,
			varchar_invoice_section_id,
			varchar_employee_id,
			varchar_labor_category_id
		);
	END IF;
		
	COMMIT;
END;